<?php

/*
	This example file shows how to use web hyphenation
	in 3 easy steps.
		
	STEP 1: ENCODING
	Use UTF-8 encoding like this:
*/	

	header('content-type: text/html; charset=utf-8');

/*
	STEP 2: SETTINGS
	Settings must be applied before including the
	"hyphenation.php". These are the default values:

	$GLOBALS["language"] = "de";
		Values: de, en, fr
		
	$GLOBALS["path_to_patterns"] = "patterns/";
		Where the patterns are located.
		
	$GLOBALS["dictionary"] = "dictionary.txt";
		You can create a text file with special words
		and those hyphenations line by line.
		Use the / to mark a hyphenation.
		For example: hyphe/nation
		
	$GLOBALS["hyphen"] = "&shy;";
		Entity or single character for hyphenation.
	
	$GLOBALS["leftmin"] = 2; $GLOBALS["rightmin"] = 2; $GLOBALS["charmin"] = 4;
		Minimum characters on left / right side and
		characters length of a word.
		
	$GLOBALS["exclude_tags"] = array("code", "pre", "script", "style");
		HTML tags to exclude from hyphenation.
	
	
	STEP 3: INCLUDING HYPHENATION.PHP
*/

	include("hyphenation.php");

/*	
	After including the file, hyphenation is available as
	normal function.
*/
	
	$text = 'Weit hinten, hinter den Wortbergen, fern der Länder Vokalien und Konsonantien leben die Blindtexte. Abgeschieden wohnen Sie in Buchstabhausen an der Küste des Semantik, eines großen Sprachozeans. Ein kleines Bächlein namens Duden fließt durch ihren Ort und versorgt sie mit den nötigen Regelialien. Es ist ein paradiesmatisches Land, in dem einem gebratene Satzteile in den Mund fliegen.';
	
	echo hyphenation($text);
?>