<?php
			/*#################################################################################
			# Project: Web Hyphenation 1.2 (c) yellowgreen designbüro                         #
			# For more information, go to http://yellowgreen.de/hyphenation.                  #
			# License: http://creativecommons.org/licenses/by-sa/3.0/                         #
			# Hyphenation online generator: http://yellowgreen.de/soft-hyphenation-generator  #
			#################################################################################*/

// SETTINGS

			if(!isset($GLOBALS["language"])) $GLOBALS["language"] = "de";
			if(!isset($GLOBALS["path_to_patterns"])) $GLOBALS["path_to_patterns"] = "patterns/";
			if(!isset($GLOBALS["dictionary"])) $GLOBALS["dictionary"] = "dictionary.txt";
			if(!isset($GLOBALS["hyphen"])) $GLOBALS["hyphen"] = "&shy;";
			if(!isset($GLOBALS["leftmin"])) $GLOBALS["leftmin"] = 2;
			if(!isset($GLOBALS["rightmin"])) $GLOBALS["rightmin"] = 2;
			if(!isset($GLOBALS["charmin"])) $GLOBALS["charmin"] = 4;
			if(!isset($GLOBALS["exclude_tags"])) $GLOBALS["exclude_tags"] = array("code", "pre", "script", "style");

// PREPARE

			mb_internal_encoding("utf-8");
			
			if(file_exists($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".php")) { include($GLOBALS["path_to_patterns"] . $GLOBALS["language"] . ".php"); $GLOBALS["patterns"] = $patterns; } else $GLOBALS["patterns"] = array();
			file_exists($GLOBALS["dictionary"]) ? $GLOBALS["dictionary"] = file($GLOBALS["dictionary"]) : $GLOBALS["dictionary"] = array();
			$GLOBALS["dictionary_words"] = $GLOBALS["dictionary"];
			for($i = 1; $i < count($GLOBALS["dictionary"]); $i++) $GLOBALS["dictionary_words"][$i] = str_replace("/", "", strtolower(trim($GLOBALS["dictionary"][$i])));

// FUNCTIONS
			
			// Function: Replace by comparing
			function str_replace_comp($needle, $replace, $string_a, $string_b) {
				$position = 0;
				while($position !== false && $position < mb_strlen($string_a)) {
					$position = mb_strpos($string_a, $needle, $position + 1);
					if($position != 0) $string_b = mb_substr($string_b, 0, $position) . $replace . mb_substr($string_b, $position);
				}
				return $string_b;
			}

			// Function: Word hyphenation
			function word_hyphenation($word) {
				if(mb_strlen($word) < $GLOBALS["charmin"]) return $word;
				
				if(($key = array_search(strtolower($word), $GLOBALS["dictionary_words"])) !== false)
					return str_replace_comp("/", $GLOBALS["hyphen"], trim($GLOBALS["dictionary"][$key]), $word);
			
				$positions = ""; $hyphenated_word = ""; $word_without_hyphen = "";
				$tex_word = " " . mb_strtolower($word) . " ";
				for($i = 0; $i < mb_strlen($tex_word); $i++) $positions .= 0;
				
				for($start = 0; $start < mb_strlen($tex_word); $start++) {
					for($length = 1; $length <= mb_strlen($tex_word) - $start; $length++) {
						$patterns_index = mb_substr(mb_substr($tex_word, $start), 0, $length);
						if(isset($GLOBALS["patterns"][$patterns_index])) {
							$values = $GLOBALS["patterns"][$patterns_index];
							$i = $start;
							
							for($p = 0; $p < mb_strlen($values); $p++) {
								$value = mb_substr($values, $p, 1);
 								if($value > $positions[$i - 1]) $positions[$i - 1] = $value;
								$i++;
							}
						}
					}
				}
				
				$positions = trim($positions);
		
				for($i = 0; $i < mb_strlen($word); $i++) {
					$word_without_hyphen = str_replace($GLOBALS["hyphen"], "", $hyphenated_word);
					if($positions[$i] % 2 != 0 && $i != 0 && $i >= $GLOBALS["leftmin"] && $i <= mb_strlen($word) - $GLOBALS["rightmin"]) $hyphenated_word .= mb_substr($word, mb_strlen($word_without_hyphen), $i - mb_strlen($word_without_hyphen)) . $GLOBALS["hyphen"];
				}
				
				$hyphenated_word .= mb_substr($word, mb_strlen($word_without_hyphen), $i - mb_strlen($word_without_hyphen));
				return $hyphenated_word;
			}

			// Function: Text hyphenation
			function hyphenation($text) {
				global $exclude_tags; $word = ""; $tag = ""; $tag_jump = 0; $output = array();
				$word_boundaries = "<>\t\n\r\0\x0B !\"§$%&/()=?….,;:-–_„”«»‘’'/\\‹›()[]{}*+´`^|©℗®™℠¹²³";
				$text = $text . " ";
				
				for($i = 0; $i < mb_strlen($text); $i++) {
					$char = mb_substr($text, $i, 1);
					if(mb_strpos($word_boundaries, $char) === false && $tag == "") {
						$word .= $char;
					} else {
						if($word != "") { $output[] = word_hyphenation($word); $word = ""; }
						if($tag != "" || $char == "<") $tag .= $char;
						if($tag != "" && $char == ">") {
							$tag_name = (mb_strpos($tag, " ")) ? mb_substr($tag, 1, mb_strpos($tag, " ") - 1) : mb_substr($tag, 1, mb_strpos($tag, ">") - 1);
							if($tag_jump == 0) {
								if(in_array($tag_name, $exclude_tags)) $tag_jump = 1; else { $output[] = $tag; $tag = ""; }
							} else { $output[] = $tag; $tag = ""; }
						}
						if($tag == "" && $char != "<" && $char != ">") $output[] = $char;
					}
				}
				
				$text = join($output);
				return substr($text, 0, strlen($text) - 1);
			}
?>